#include <stdio.h>
#include "sim.h"

breakPoint *bptLists[3]= { NULL, NULL, NULL };  /* List of each type of bpt */
extern breakPoint *bptTails[3];

int numBpts[3]= { 0, 0, 0 };  /* Number of each type of breakpoint
				 (read, write, fetch) */

void addBpt(int locn, int type)
{
 breakPoint *bpt= (breakPoint*)malloc(sizeof(breakPoint));
 bpt->type= type;
 bpt->locn= locn;
 bpt->next= bptLists[type];
 bptLists[type]= bpt;
 ++numBpts[type];
}

int chkBpt(int locn, int type, int size)
{
 breakPoint *bpt;
 int mask= (size == 1 ? 0xffffffff : (size == 2 ? 0xfffffffe : 0xfffffffc));
 for (bpt= bptLists[type]; bpt; bpt= bpt->next)
  if ((bpt->locn & mask) == (locn & mask))
   return 1;
 return 0;
}

void rmBpt(int locn, int type)
{
 breakPoint *bpt, *lbpt= NULL;
 for (bpt= bptLists[type]; bpt && bpt->locn != locn;
      lbpt= bpt, bpt= bpt->next);
 if (bpt) /* found it */
 {
  if (lbpt)
   lbpt->next= bpt->next;
  else
   bptLists[type]= bptLists[type]->next;
  --numBpts[type];
 }
 else
  printf("rmBpt PANIC: removing non-existent breakpoint at locn %d\n", locn);
}

void rmBptNo(int num, int type)
{
 breakPoint *bpt, *lbpt= NULL;
 int i;
 for (bpt= bptLists[type], i=0; bpt && i != num;
      lbpt= bpt, bpt= bpt->next, ++i);
 if (bpt) /* found it */
  {
   if (lbpt)
    lbpt->next= bpt->next;
   else
    bptLists[type]= bptLists[type]->next;
   --numBpts[type];
  }
 else
  printf("rmBpt PANIC: removing non-existent breakpoint #%d\n", num);
}

void clearAllBpts()
{
 breakPoint *bpt, *nbpt;
 int i, type;
 for (i=0; i < 3; ++i)
 {
  switch (i)
  {
   case 0: type= READ_BPT;
   case 1: type= WRITE_BPT;
   case 2: type= FETCH_BPT;
  }
  for (bpt= bptLists[type]; bpt; bpt= nbpt)
  {
   nbpt= bpt->next;
   free(bpt);
  }
  bptLists[type]= NULL;
 }
}
 
